/* 
** $VER: SV_Export.rexx 1.0, IE Arexx script
** Image Engineer Macro script
** Copyright  by Patrik M Nydensten 
** 9/1 1997 Stockholm/Sweden
**
** This arexx script will export the PRIMARY image in Image Engineer
** to SuperView. Both programs must be running at the same time.
** This script was developed to work with SuperView 5.70 and
** Image Engineer 3.3.
**
*/

OPTIONS RESULTS
SIGNAL ON ERROR
TEMP_FILE = 't:Image_from_IE'
PORT = 'SuperView.rx'

if arg()==0 then exit

/* Main code */

IF ~SHOW('P',PORT) THEN DO
  'REQUEST' '"Could not locate SuperView'x2c(27)'s arexx port!"' '" OK "'
  CALL ErrorOut 0
END

'SAVE_DATA' arg(1) '"'||TEMP_FILE||'"' '"ILBM CmpByteRun1"'
IF (RC ~= 0) THEN DO
 	'REQUEST' '"Error when saving temporary image!"' '" OK "'
	CALL ErrorOut 10
END

'WB_TO_FRONT'

ADDRESS VALUE PORT

'LOAD=' || TEMP_FILE
IF (RC ~= 0) THEN DO
  ADDRESS 'IMAGEENGINEER'
  'IE_TO_FRONT'
 	'REQUEST' '"Error loading image into SuperView!"' '" OK "'
	CALL ErrorOut 10
END

CALL ErrorOut 0

/* Errorout procedure ----------------------- */

ErrorOut:
	PARSE ARG ExitCode

	IF (EXISTS( TEMP_FILE )) THEN DO
  	ADDRESS COMMAND "Delete >NIL:" TEMP_FILE
  END
  
	EXIT ExitCode

/* IE's error procedure --------------------- */

Error:
if RC=5 then do
  'IE_TO_FRONT'
  'LAST_ERROR'
  'REQUEST "'||RESULT||'"'
end
else do
  'IE_TO_FRONT'
  'LAST_ERROR'
  'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
end
CALL ErrorOut 0
